//------------------------------------------------------------
//		 wxWidget with Direct3D9
//------------------------------------------------------------
// ۼ : 
// http://lancekun.com
// ׽Ʈȯ Դϴ. Ÿ÷ ó ؼ..
// (? Directü ۿʵڳ)
// Ϸ :VS2008 SP1
// ̺귯 :wxWidgets-2.8.10 

// wxWidget 
#include "wx/wxprec.h"
#ifndef WX_PRECOMP
#include "wx/wx.h"
#endif

// DirectX  Ϲ ̺귯ũ
#include <d3dx9.h>
#pragma comment(lib,"d3d9.lib")
#pragma comment(lib,"d3dx9.lib")

// Ŭ
class SamepleApp : public wxApp{
public:
	virtual bool OnInit();
};
//   wxFrame
class SampleFrame : public wxFrame{
protected: // Directüص̽
	LPDIRECT3D9             m_pD3D;
	LPDIRECT3DDEVICE9       m_pd3dDevice;
public:
	//* D3D ʱȭϴ Լ
	VOID D3DInit(int width,int height){
		wxPanel * panel=new wxPanel(this,wxID_ANY);
		// D3Düκ
		m_pD3D = Direct3DCreate9( D3D_SDK_VERSION );
		D3DPRESENT_PARAMETERS d3dpp;
		ZeroMemory( &d3dpp, sizeof(d3dpp) );
		d3dpp.Windowed               = TRUE;
		d3dpp.SwapEffect             = D3DSWAPEFFECT_DISCARD;
		d3dpp.BackBufferFormat       = D3DFMT_X8R8G8B8;
		d3dpp.BackBufferWidth        = width;		
		d3dpp.BackBufferHeight       = height;	
		//* ̽ ϴ κ 
		//* wxPanel::GetHWND  HWND  ĳϿ ־ش.
		m_pD3D->CreateDevice(D3DADAPTER_DEFAULT,D3DDEVTYPE_HAL,(HWND)panel->GetHWND(),D3DCREATE_HARDWARE_VERTEXPROCESSING|D3DCREATE_MULTITHREADED,&d3dpp,&m_pd3dDevice);
	}
public:
	SampleFrame(const wxString& title);// 
	void OnRender(wxEraseEvent& event);	// Լ
private:
	// ̺Ʈ ̺ 
	DECLARE_EVENT_TABLE()
};

// ̺Ʈ̺
BEGIN_EVENT_TABLE(SampleFrame, wxFrame)
//  Լ ش.
EVT_ERASE_BACKGROUND(SampleFrame::OnRender) 
END_EVENT_TABLE()

//  APPŬ
IMPLEMENT_APP(SamepleApp)

// App ʱȭ
bool SamepleApp::OnInit(){
	SampleFrame *frame = new SampleFrame(_("wxWidgets with DirectX"));

	//* D3DʱȭԼ ȣϿ D3Dü ̽ ش.
	frame->D3DInit(800,600);

	frame->Show();
	return true;
}

// Լ
void SampleFrame::OnRender(wxEraseEvent& event){
	m_pd3dDevice->SetRenderState( D3DRS_LIGHTING, FALSE ); // ǻ̱ 
	//  RGB(0,128,128) ʱȭѴ
	m_pd3dDevice->Clear( 0, NULL, D3DCLEAR_TARGET, D3DCOLOR_ARGB(255, 0, 128, 128), 1.0f, 0 ); 
	if( FAILED( m_pd3dDevice->BeginScene())) // ׸ 
		return ;
	// ׸ ؽ ü
	struct CUSTOMVERTEX{
		float fX,fY,fZ;
		DWORD dwColor;
	};
	// ׷ ؽ 3 (ﰢ)
	CUSTOMVERTEX g_lineVertices[] = {
		{ -0.5f, 0.0f, 0.0f,  0xff0000ff }, 
		{ 0.0f, 0.5f, 0.0f, 0xffff0000 },
		{ 0.5f, 0.0f, 0.0f,  0xff00ff00 }, 
	};
	m_pd3dDevice->SetFVF(D3DFVF_XYZ | D3DFVF_DIFFUSE );// ؽ FVF
	m_pd3dDevice->DrawPrimitiveUP( D3DPT_TRIANGLELIST, 1, g_lineVertices, sizeof( CUSTOMVERTEX ) ); // ׷ֱ
	m_pd3dDevice->EndScene();// ׸ 
	m_pd3dDevice->Present(NULL,NULL,(HWND)this->GetHWND(),NULL);// ȭ鿡ѷ
}

// ʱȭԼ
// wxWidgetø ʿ.
SampleFrame::SampleFrame(const wxString& title)
: wxFrame((wxFrame *)NULL, wxID_ANY, title,wxDefaultPosition,wxSize(800,600)){//wxSize(w,h)
	wxBoxSizer * vbox = new wxBoxSizer(wxVERTICAL);
	wxToolBar *toolbar = new wxToolBar(this,-1);
	toolbar->AddSeparator();
	toolbar->Realize();
	vbox->Add(toolbar,0,wxEXPAND);
	SetSizer(vbox);
	wxMenu *menuFile;
	wxMenuBar *menuBar = new wxMenuBar;
	menuFile = new wxMenu;
	menuFile->Append(-1,"&New File\tCtrl-N");
	menuFile->Append(-1,"&Load Chacter\tCtrl-L");
	menuFile->AppendSeparator();
	menuFile->Append(-1,"&Exit\tCtrl-E");
	menuBar->Append(menuFile, _("&File"));
	SetMenuBar(menuBar);
}